<?php

/**
 * presup_tiquete_area actions.
 *
 * @package    controlComisiones
 * @subpackage presup_tiquete_area
 * @author     Dany Ortega
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class presup_tiquete_areaActions extends sfQuery
{
 /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'COM_PRESUP_TIQUETES_AREA', 'AREA'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'AREA' =>
        array(
            'id_area' => 'COM_PRESUP_TIQUETES_AREA'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'COM_PRESUP_TIQUETES_AREA' =>
        array(
            'id_presup_tiquetes_area' => 'id_presup_tiquetes_area',
            'id_area' => 'id_area',
            'valor' => 'valor',
            'vigencia' => 'vigencia',
            'fecha' => 'fecha',
            'observacion' => 'observacion',
            'usuariolog' => 'usuariolog'
        ),
        'AREA' =>
        array(
            'descripcion' => 'descripcion',
            'sigla' => 'sigla',
            'id_dependencia' => 'id_dependencia',
            'codigo' => 'codigo',
            'id_nivel' => 'id_nivel'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
        'vigencia', 'id_area'
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'COM_PRESUP_TIQUETES_AREA' =>
        array(
            'id_presup_tiquetes_area,a' => array('!=' => array(-1)),
            'id_presup_tiquetes_area,b' => array('=' => array('id_presup_tiquetes_area')),
            'id_area' => array('=' => array('id_area')),
            'vigencia' => array('=' => array('vigencia')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_presup_tiquetes_area'; //identificador de la tabla
    protected $id_names = array('id_presup_tiquetes_area'); //llave primaria
    protected $field_names = array('id_presup_tiquetes_area', 'id_area', 'valor', 'vigencia', 'fecha','observacion','usuariolog'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'COM_PRESUP_TIQUETES_AREA'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_presup_tiquetes_area'; //identificador unico de la tabla
   
    
    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        //$logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            $request['usuariolog']=$request['username'];
        }    

       //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;
        /*
         *  Validar la operación, ya sea por SQL
         */


        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateRemove(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */
        //VALIDAR QUE LA FECHA SE ENCUENTRE EN EL RANGO DE FECHAS DEL COMISIONADO
        //20170526 Validamos que con la compra del tiquete no se exceda el presupuesto del area para tiquetes
        //si no existe registro de presupuesto o el presupuesto es 0 para la vigencia y departamento se omite esta validacion
        $id_presupuesto=$request['id_presup_tiquetes_area'];
        $sql = <<<EOD
select * from COM_PRESUP_TIQUETES_AREA where id_presup_tiquetes_area=$id_presupuesto
EOD;
        $records = CN_TABLE::executeSQL($sql);
        if(count($records)>0){
            //obtenemos e monto del presupuesto a borrar 
            $montoborrar=$records[0]['valor'];
        }
        $sql = <<<EOD
select 
*
from com_estado_presup_tiquetes_v tab0
    where id_area=(select id_area from COM_PRESUP_TIQUETES_AREA where id_presup_tiquetes_area=$id_presupuesto) 
    and vigencia=(select vigencia from COM_PRESUP_TIQUETES_AREA where id_presup_tiquetes_area=$id_presupuesto)
EOD;
        $records = CN_TABLE::executeSQL($sql);
        if(count($records)>0){
            //capturamos valores del estado del presupuesto
            $presupuesto=$records[0]['presupuesto'];
            $gastado=$records[0]['gastos_tiquetes'];
            $saldo=$records[0]['saldo'];
            //si el presupuesto - el monto a borrar es menor a lo gastado en tiquetes generamos el error
            if(($presupuesto-$montoborrar)<$gastado && $presupuesto>0){
                $errors['mensaje'] = "No se puede borrar borrar el detalle del presupuesto, ya que el monto gastado en tiquetes para el area excederia el presupuesto restante.";
                $errors['servicio'] = "presup_tiquete_area";
            }
        }

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

            /*
             *  Validar la operación, ya sea por SQL
             */

            /*
             *  Generar errores en $errors
             */
        return $errors;
    }
}
